# Information Schema USER\_VARIABLES Table

## Description

The `USER_VARIABLES` table is created when the [user\_variables](/docs/server/reference/plugins/other-plugins/user-variables-plugin.md) plugin is enabled, and contains information about [user-defined variables](/docs/server/reference/sql-structure/sql-language-structure/user-defined-variables.md).

The table contains the following columns:

| Column               | Description                                                                             |
| -------------------- | --------------------------------------------------------------------------------------- |
| VARIABLE\_NAME       | Variable name.                                                                          |
| VARIABLE\_VALUE      | Variable value.                                                                         |
| VARIABLE\_TYPE       | Variable [type](/docs/server/reference/data-types.md).                                  |
| CHARACTER\_SET\_NAME | [Character set](/docs/server/reference/data-types/string-data-types/character-sets.md). |

User variables are reset and the table emptied with the [FLUSH USER\_VARIABLES](/docs/server/reference/sql-statements/administrative-sql-statements/flush-commands/flush.md) statement. `SHOW USER_VARIABLES` displays a subset of the data.

## Example

```sql
SET @v1 = 0;
SET @v2 = 'abc';
SET @v3 = CAST(123 AS CHAR(5));

SELECT * FROM information_schema.USER_VARIABLES ORDER BY VARIABLE_NAME;
+---------------+----------------+---------------+--------------------+
| VARIABLE_NAME | VARIABLE_VALUE | VARIABLE_TYPE | CHARACTER_SET_NAME |
+---------------+----------------+---------------+--------------------+
| v1            | 0              | INT           | latin1             |
| v2            | abc            | VARCHAR       | utf8               |
| v3            | 123            | VARCHAR       | utf8               |
+---------------+----------------+---------------+--------------------+

SHOW USER_VARIABLES;
+---------------+-------+
| Variable_name | Value |
+---------------+-------+
| v3            | 123   |
| v2            | abc   |
| v1            | 0     |
+---------------+-------+
```

## See Also

* [User-defined variables](/docs/server/reference/sql-structure/sql-language-structure/user-defined-variables.md)
* [Performance Schema user\_variables\_by\_thread Table](/docs/server/reference/system-tables/performance-schema/performance-schema-tables/performance-schema-user_variables_by_thread-table.md)

<sub>*This page is licensed: CC BY-SA / Gnu FDL*</sub>

{% @marketo/form formId="4316" %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://mariadb.com/docs/server/reference/system-tables/information-schema/information-schema-tables/information-schema-user_variables-table.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
